//
// Implementazione della Classe Stack.
// Utilizzo di templates ed ereditarieta`.
//


#include <iostream.h>
#include "Stack4.H"


// Costruttore per il tipo di dato Pila.
BaseStack::BaseStack()
{
  len = 0;		// La Pila e` vuota
  head = NULL;		// La testa non punta da nessuna parte
}


// Distruttore per il tipo di dato Pila.
BaseStack::~BaseStack()
{
  while (len) {
    Pop();
  }
}


// Restituisce l'elemento in testa alla Pila
BaseNode * BaseStack::Read()
{
  if (IsEmpty()) {
    cerr << "Errore: la Pila e` vuota!" << endl;
    exit(-2);
  }

  return(head);
}


// Rimuove un elemento dalla testa della Pila
BaseNode *BaseStack::Pop()
{
  BaseNode *tmp;

  if (IsEmpty()) {
    cerr << "Errore: la Pila e` vuota!" << endl;
    exit(-2);
  }
  else {
    tmp = head;			// Salvo il puntatore alla testa della Pila
    head = head->next;		// Sposto la testa della Pila
    len--;
  }

  return(tmp);			// Restituisco la vecchia testa della Pila
}


// Inserisce l'elemento d in testa alla Pila
void BaseStack::Push(BaseNode *d)
{
  d->next = head;		// Il campo next punta alla testa della Pila
  head = d;			// Sposto la testa della Pila
  len++;
}
